-- Vray Proxy Time Shifter v1.0   (31-01-2018) 
-- Author: Alaa Alnahlawi  --
-- www.vfxarabia.co --

try(destroyDialog vrpts)catch()
rollout vrpts "Vray Proxy Time Shifter" width:160 height:272
(
	local alarray=#(), obj=undefined, dist=0, rand=0
	fn helper_filt Obj = SuperClassOf Obj == helper 
	
	
	GroupBox 'grp1' "Offset based on distance" pos:[8,8] width:144 height:152 align:#left
	pickbutton 'Pickhelper_btn' "Select a Source" pos:[16,32] width:128 height:24 filter:helper_filt align:#left 
	label 'lbl6' "Bias:" pos:[16,64] width:48 height:16 align:#left
	button 'btn1' "Offset" pos:[16,136] width:128 height:16 align:#left
	spinner 'bias_spn' "" pos:[96,64] width:47 height:16 range:[0,2,1] type:#float scale:0.1 align:#left
	spinner 'spn3' "" pos:[96,88] width:47 height:16 range:[0,1000,0.1] type:#float scale:0.1 align:#left
	label 'lbl3' "Multiplier:" pos:[16,88] width:64 height:16 align:#left
	label 'lbl11' "Random:" pos:[16,112] width:64 height:16 align:#left
	spinner 'rand_spn1' "" pos:[96,112] width:47 height:16 range:[0,10000,0] type:#integer scale:1 align:#left
	
	
	GroupBox 'grp6' "Input a start frame" pos:[8,168] width:144 height:96 align:#left
	label 'lbl1' "Start frame:" pos:[16,192] width:72 height:16 align:#left
	spinner 'spn1' "" pos:[96,192] width:47 height:16 range:[-10000,10000,0] type:#integer scale:1 align:#left
	button 'btn15' "Offset" pos:[16,240] width:128 height:16 align:#left
	label 'lbl10' "Random:" pos:[16,216] width:72 height:16 align:#left
	spinner 'rand_spn2' "" pos:[96,216] width:47 height:16 range:[0,10000,0] type:#integer scale:1 align:#left
	

	on Pickhelper_btn picked hlp do
	(
	Pickhelper_btn.text =  hlp.name
	)
	
	on btn1 pressed do
	(
		alarray=#()
		alarray=Getcurrentselection ()
		Case of
		(
		(Pickhelper_btn.object==undefined): (messagebox "Select a distance source to do the measure")
		(alarray.count == 0): (messagebox "Select a vray proxy object")
		Default:
		
		for i = 1 to alarray.count do
		(
		if classof alarray[i]==VRayProxy then
		(
		rand=random(-rand_spn1.value) (rand_spn1.value)
		obj= Pickhelper_btn.object
		dist= distance obj.pos alarray[i].pos
		alarray[i].use_alembic_offset = off
		alarray[i].anim_offset = ((dist ^ bias_spn.value)*spn3.value) + rand
		)
		else
		(
			messagebox "Make sure all of your selection is vray proxy object"
		)
		)
		)
	)
	
	on btn15 pressed do
	(
		alarray=#()
		alarray=Getcurrentselection ()
		Case of
		(
		(alarray.count == 0): (messagebox "Select a vray proxy object")
		Default:	
		
		for i = 1 to alarray.count do
		(
		if classof alarray[i]==VRayProxy then
		(
		rand=random(-rand_spn2.value) (rand_spn2.value)
		alarray[i].use_alembic_offset = off
		alarray[i].anim_offset = spn1.value + rand
		)
		else
		(
			messagebox "Make sure all of your selection is vray proxy object"
		)
		)
		)
	)
)
createdialog vrpts